/******************************************************************************
 CIconPane.h

		Interface for IconPane class
		
	SUPERCLASS = CPane
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CIconPane

#include "CPane.h"

#define kIconPixels		32		/* ICON is 32 pixels square		*/
#define kIconBytes		128		/* ICON is 128 bytes of data	*/
#define kIconRowBytes	4		/* 32 b&w pixels is 4 bytes		*/

class CIconPane : public CPane
{	
public:

	void 	IIconPane( CView *anEnclosure, CBureaucrat *aSupervisor,
					short aHEncl, short aVEncl,
					SizingOption aHSizing, SizingOption aVSizing,
					short iconID, Boolean fPreferColor);
					
	virtual void 	IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
						Ptr viewData);

	virtual void 	Draw( Rect *area);
	
	virtual void 	DoClick( Point hitPt, short modifierKeys, long when);

	virtual void 	SetClickCmd( long aCmd);
	virtual long 	GetClickCmd( void);
	
	virtual void 	Dispose( void);

protected:

	short		iconID;
	char		icon[kIconBytes];
	CIconHandle	cicnH;
	long		clickCmd;
	
	static BitMap	cMaskBitMap;
	static char 	cIconMaskBits[kIconBytes];
	static Boolean	cHaveIconDispatch;	// TCL 1.1.2
						
	void 	IIconPaneX( Boolean fPreferColor);	
	virtual void 	DrawIcon( Boolean fHilite);				
	virtual Boolean Track( void);
};

typedef struct tIconPaneTemp
{
	PaneTemp	paneTemp;
	short		iconID;
	Boolean		fPreferColor;
	long		clickCmd;

} tIconPaneTemp, *tIconPaneTempP;