/******************************************************************************
 CControl.h

		Interface for the Control Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added constants for CControl change protocol.
		- added Show method
		- added overrride of RefreshLongRect
	]

 ******************************************************************************/
 
#define _H_CControl

#include "CPane.h"						/* Interface for its superclass		*/
#include "Global.h"

class CControl : public CPane {				/* Class Declaration				*/

public:
								/** Instance Variables **/
	ControlHandle	macControl;			/* Toolbox control record			*/
	
								/** Instance Methods **/
								
							
									/** Destruction **/
	virtual void			Dispose(void);
	
									/** Accessing **/
	virtual void			SetValue(short aValue);
	virtual short			GetValue(void);
	virtual void			SetMaxValue(short aMaxValue);
	virtual short			GetMaxValue(void);
	virtual void			SetMinValue(short aMinValue);
	virtual short			GetMinValue(void);
	virtual void			SetTitle(Str255 aTitle);
	virtual void			GetTitle(Str255 aTitle);
	virtual void			SetActionProc(VoidFunc anActionProc);

									/** Manipulating **/									
	virtual void			Show(void);
	virtual void			Hide(void);
	virtual void			Activate(void);
	virtual void			Deactivate(void);
	virtual void			Offset(long hOffset, long vOffset, Boolean redraw);
	virtual void			ChangeSize(Rect *delta, Boolean redraw);

									/** Drawing **/
	virtual void			Draw(Rect *area);
	virtual void			DrawAll(Rect *area);
	virtual void			Prepare( void);
	virtual void			PrepareToPrint( void);	/* TCL 1.1.1 DLP 9/18/91 */
	virtual void			RefreshLongRect( LongRect *area);
		
									/** Click Response **/
	virtual void			DoClick(Point hitPt, short modifierKeys, long when);
	virtual void			DoThumbDragged(short delta);
	virtual void			DoGoodClick(short whichPart);
};

/* Change protocol for CControl */

enum
{
			/* The value of the control has changed. The info parameter is	*/
			/* a pointer (short*) to the new value 							*/
	controlValueChanged = bureaucratLastChange + 1,
	
	controlLastChange = controlValueChanged
	
};

typedef struct CNTLtemplate	// format of a 'CNTL' resource
{
	Rect	boundsRect;
	short	value;
	short	visible;
	short	max;
	short	min;
	short	procID;
	long	refcon;
	Str255	title;
	
} CNTLtemplate, *CNTLtemplatePtr, **CNTLtemplateHndl;