/******************************************************************************
 CDirector.h

		Interface for the Director Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

	TCL 1.1 CHANGES
	[
		- added GetWindow, FindViewByID methods
		- added override of ProviderChanged
		- added activateWindOnResume instance variable
	]
	
 ******************************************************************************/
 
#define _H_CDirector

#include "CDirectorOwner.h"				/* Interface for its superclass		*/

class CWindow;
class CView;

class CDirector : public CDirectorOwner {		/* Class Declaration				*/

public:
								/** Instance Variables **/
	CWindow		*itsWindow;				/* Window which object directs		*/
	CBureaucrat	*itsGopher;				/* Bureaucrat to make the Gopher	*/
										/*   when Director is activated		*/
	Boolean		activateWindOnResume;	/* activate window on Resume?		*/
	Boolean		alreadyClosing;			/* TRUE while attempting to Close	*/
										/* the director						*/
										/* TCL 1.1.1 DLP 9/18/91			*/
	
								/** Instance Methods **/
                                
    
    void        IDirector( CDirectorOwner *aSupervisor);
	virtual void		Dispose(void);

	virtual void		DoCommand(long theCommand);
	virtual void		UpdateMenus(void);
	
	virtual void		Activate(void);
	virtual void		Deactivate(void);
	virtual void		Suspend(void);
	virtual void		Resume(void);
	virtual Boolean		Close(Boolean quitting);
	virtual void		CloseWind(CWindow *theWindow);
	virtual void		ActivateWind(CWindow *theWindow);
	virtual void		DeactivateWind(CWindow *theWindow);
	virtual Boolean		IsActive(void);
	virtual void 		ActivateDirector( CDirector *aDirector);
	virtual void 		DeactivateDirector( CDirector *aDirector);
	virtual void 		RemoveDirector( CDirector *aDirector);
	
	virtual Boolean		OwnsWindow( CWindow *aWindow);
		
	virtual CWindow		*GetWindow( void);
	virtual CView*		FindViewByID( long aViewID);
	virtual void		ProviderChanged( CCollaborator *aProvider, long reason, void* info);

};

	// symbolic constants for Boolean parameters
enum
{
	kNotQuitting = FALSE,
	kQuitting
};